unit hiCryptRC2;

interface

uses Kol,Share,Debug,KOLBlockCipher,KOLSHA512;

type
  THICryptRC2 = class(TDebug)
   private
    Hash: TKOLSHA512;
    RC2:TKOLRC2;
    function MakeKey(passw:string; var DigBuf):boolean;
   public
    _prop_FileName:string;
    _prop_NewFileName:string;
    _prop_Password:string;

    _event_onResult:THI_Event;
    _event_onStream:THI_Event;
    _event_onStreamResult:THI_Event;
    _data_FileName:THI_Event;
    _data_NewFileName:THI_Event;
    _data_Stream:THI_Event;
    _data_Password:THI_Event;

    procedure _work_doPack(var _Data:TData; Index:word);
    procedure _work_doUnpack(var _Data:TData; Index:word);
    procedure _work_doPackStream(var _Data:TData; Index:word);
    procedure _work_doUnpackStream(var _Data:TData; Index:word);
  end;

var DigBuf: array [0..31] of byte;

implementation

function THICryptRC2.MakeKey;
begin
  Hash:=KOLSHA512.NewSHA512;
  Hash.InitHash;
  Hash.UpdateStr(passw);
  Hash.Final(DigBuf);
  Hash.Burn;
end;

procedure THICryptRC2._work_doPack;
var sfile,dfile,pass:string;
    i:integer;
begin
  sfile:=ReadString(_Data,_data_FileName,_prop_FileName);
  dfile:=ReadString(_Data,_data_NewFileName,_prop_NewFileName);
  pass:=ReadString(_Data,_data_Password,_prop_Password);
   if (FileExists(sfile)) then
    begin
     MakeKey(pass,DigBuf);
     RC2:=KOLBlockCipher.NewRC2;
     RC2.InitKey(DigBuf,512);
     i:=byte(RC2.EncryptFile(sfile,dfile));
     RC2.Burn;
     _hi_OnEvent(_event_onResult,i);
    end;
end;

procedure THICryptRC2._work_doUnpack;
var sfile,dfile,pass:string;
    i:integer;
begin
  sfile:=ReadString(_Data,_data_FileName,_prop_FileName);
  dfile:=ReadString(_Data,_data_NewFileName,_prop_NewFileName);
  pass:=ReadString(_Data,_data_Password,_prop_Password);
   if (FileExists(sfile)) then
    begin
     MakeKey(pass,DigBuf);
     RC2:=KOLBlockCipher.NewRC2;
     RC2.InitKey(DigBuf,512);
     i:=byte(RC2.DecryptFile(sfile,dfile));
     RC2.Burn;
     _hi_OnEvent(_event_onResult,i);
    end;
end;

procedure THICryptRC2._work_doPackStream;
var  st,dest:PStream;
     pass:string;
     SrcBuf,DestBuf : array[1..4096] of byte;
     i,BytesRead:  integer;
begin
   pass:=ReadString(_Data,_data_Password,_prop_Password);
   st := ReadStream(_data,_data_Stream,nil);
   if st <> nil then
    begin
     st.Position := 0;
     dest := NewMemoryStream;
     MakeKey(pass,DigBuf);
     RC2:=KOLBlockCipher.NewRC2;
     RC2.InitKey(DigBuf,512);
      repeat
       BytesRead:=St.Read(SrcBuf,SizeOf(SrcBuf));
       if bytesRead>0 then
        begin
         RC2.EncryptDataBlock(SrcBuf,DestBuf,bytesRead);
         dest.Write(DestBuf,bytesRead);
         i:=i+bytesRead;
         _hi_OnEvent(_event_onStreamResult,i);
        end;
      until BytesRead = 0;
     dest.Position := 0;
     _hi_OnEvent(_event_onStream,dest);
     dest.Free;
    end;
end;

procedure THICryptRC2._work_doUnpackStream;
var  st,dest:PStream;
     pass:string;
     SrcBuf,DestBuf : array[1..4096] of byte;
     i,BytesRead:  integer;
begin
   pass:=ReadString(_Data,_data_Password,_prop_Password);
   st := ReadStream(_data,_data_Stream,nil);
   if st <> nil then
    begin
     st.Position := 0;
     dest := NewMemoryStream;
     MakeKey(pass,DigBuf);
     RC2:=KOLBlockCipher.NewRC2;
     RC2.InitKey(DigBuf,512);
      repeat
       BytesRead:=St.Read(SrcBuf,SizeOf(SrcBuf));
       if bytesRead>0 then
        begin
         RC2.DecryptDataBlock(SrcBuf,DestBuf,bytesRead);
         dest.Write(DestBuf,bytesRead);
         i:=i+bytesRead;
         _hi_OnEvent(_event_onStreamResult,i);
        end;
      until BytesRead = 0;
     dest.Position := 0;
     _hi_OnEvent(_event_onStream,dest);
     dest.Free;
    end;
end;

end.
